
//	Copyright 2010 PaletteSoft LLC

//	*     *   ***   ******* *     *                                           
//	**   **  *   *     *    **    *                                           
//	* * * * *     *    *    * *   *                                           
//	*  *  * *     *    *    *  *  *                                           
//	*     * *******    *    *   * *                                           
//	*     * *     *    *    *    **                                           
//	*     * *     * ******* *     *                                           

// ===========================================================================
// =	CL^															 =
// ===========================================================================
//	002 2010.??.??
//	E
// ---------------------------------------------------------------------------
//	001 2010.07.29
//	EVK쐬
// ===========================================================================


#define	SYSTEM_NAME				"SHT11 LIBRARY TEST"					//	VXe
#define	COPYRIGHT				"Copyright 2010 PaletteSoft LLC"		//	쌠

// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************

	//	*****  *****


	//	***** 錾 *****

#include	"_AtrDef.h"													//	萔Af[^^̐錾
#include	"version.h"													//	o[Wԍ̒`

	//	*****  *****

#include	"device.h"													//	foCX
#include	"DrvSht.h"													//	rgsCu

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************


// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************

	UB		vDspBuf[16];												//	ҏWp

// ***************************************************************************
// *	e[u															 *
// ***************************************************************************

	//	***** VXe *****

const	UB		tSystemName[] = SYSTEM_NAME;							//	VXe̕
const	UB		tCopyright[] = COPYRIGHT;								//	쌠\
const	UB		tVersion[] = {											//	o[Wԍ
					VER1 | '0', VER2 | '0', '.', VER3 | '0', VER4 | '0', CODE_NUL
};

	//	*****  *****

const	UB		tCrLf[] = "\r\n";										//	bqCke

const	UB		tCnvHexAscL[16] = {										//	Srbg̐lPUȋ啶R[hɕϊ
	'0',	'1',	'2',	'3',	'4',	'5',	'6',	'7',
	'8',	'9',	'A',	'B',	'C',	'D',	'E',	'F',
};

// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************


// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************

	//	***** }lWg *****

void	main(void);
void	MngSensorReset(void);
UB		MngSensorStatus(UB Reso);
UB		MngSensorTmp(void);
UB		MngSensorHum(void);
void	MngSensorNG(void);
void	MngSensorOK(void);

	//	***** \ *****

void	MngDspHello(void);
void	MngDspCrLf(void);

	//	***** Cu *****

UB*		LibHexAscUB(UB *Buffer, UB Value);
UH		LibDivUH(UH Value1, UH Value2);
UW		LibMulUH(UH Value1, UH Value2);
UB		LibPickDigit(UH *Value, UH KeyNum);
void	LibItoA4(UB *Buffer, UH Value);

// ***************************************************************************
// *	{															 *
// ***************************************************************************

//	
//	
//
// 		}lWg
//
//	
//	
void	Mng______(void) {}												//	op֐

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
void	main(void)
{
	UB		ShtReso;													//	ZT\[h
	UB		ReqReset;													//	Zbgv

	//	***** ͂߂ *****

	di();																//	荞݋֎~𖾎

	DevInit();															//	foCXݒ
	DevComInit();														//	ʐM䏉ݒ

	DrvShtInit();														//	rgsfoCX䏉ݒ

	//	***** NAs[ *****

	MngDspHello();														//	uN\

	//	***** ZN^F *****

	DevComSendData("Resolution is ");									//	\
	if (DevSigGetSw() == 0) {											//	ZN^͂kxH
		ShtReso = SHT_STATUS_RESO_1214;									//	\[h
		DevComSendData("Tmp:14bits, Hum:12bits");						//	ݒe\
	}
	else {																//	ZN^͂gx
		ShtReso = SHT_STATUS_RESO_0812;									//	\[h
		DevComSendData("Tmp:12bits, Hum: 8bits");						//	ݒe\
	}
	MngDspCrLf();														//	bqAke

	//	*****  *****

	while (1) {															//	ُ̕˂傫ȏ

		MngDspCrLf();													//	bqAke
		MngDspCrLf();													//	bqAke

		MngSensorReset();												//	ZbgR}h𔭍s
		MngDspCrLf();													//	bqAke

		//	***** ݒ菄 *****

		ReqReset = FALSE;												//	Zbgv

		while (ReqReset == FALSE) {										//	ZT̐ݒ܂߂

			//	***** Xe[^XWX^ݒ *****

DevSigPR_S0_H();
			if (MngSensorStatus(ShtReso) == 0) {						//	Xe[^XWX^̐ݒ莸sH
DevSigPR_S0_L();
				break;													//	Eo@|@Zbg
			}
DevSigPR_S0_L();
			MngDspCrLf();												//	bqAke

			//	***** 菄 *****

			while (1) {													//	菄

				//	***** x *****

DevSigPR_T0_H();
				if (MngSensorTmp() == 0) {								//	x莸sH
DevSigPR_T0_L();
					ReqReset = TRUE;									//	Zbgv
					break;												//	Eo@|@Zbg
				}
DevSigPR_T0_L();

				//	***** x *****

DevSigPR_H0_H();
				if (MngSensorHum() == 0) {								//	x莸sH
DevSigPR_H0_L();
					ReqReset = TRUE;									//	Zbgv
					break;												//	Eo@|@Zbg
				}
DevSigPR_H0_L();

				MngDspCrLf();											//	bqAke

				//	***** ҋ@ *****

#ifdef __DEBUG															//	fobO[hrhH
				DevTimWaitMs(2);										//	Q~bҋ@
#else																	//	^[Qbg[hrh
				DevTimWaitSec(2);										//	Qbҋ@
#endif
			}
		}

		//	***** ُ팟o̘AR}hs}~ *****

		DevTimWaitSec(1);												//	Pbҋ@@c@\̌hCɂđ҂Ă݂
	}

	//	***** ܂ *****

	;																	//	Bꏊ
}

//============================================================================
//	ZTFZbg
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ZTZbg܂B
//			͗L܂񂪁ÃZTւ̃R}h̓ZbgԌoߌ
//			Ɏw肵ĉB
//			ݒe̓fBtHgɖ߂܂Bʏ͍𑜓x[hłA
//			x[hősꍇ̓Xe[^XWX^̍Đݒ肪KvłB
//============================================================================
void	MngSensorReset(void)
{
	DevComSendData("*** Device Reset");									//	󋵕\

	DrvShtReset();														//	rgsfoCXZbg
	DevTimWaitMs(11);													//	Zbgҋ@@c@厖

	MngSensorOK();														//	󋵕\Fnj
	MngDspCrLf();														//	bqAke
}

//============================================================================
//	ZTFXe[^XWX^
//----------------------------------------------------------------------------
//	́F	\
//	óF	ʁiOFُIAOFIj
//----------------------------------------------------------------------------
//	lF	w肳ꂽ\ZTɐݒ肵AǂݏomFs܂B
//			^p@x[hȂsvƂΕsvłB
//============================================================================
UB		MngSensorStatus(UB Reso)
{
	UB		RegW, RegR;													//	WX^̒l
	sShtS	Status;														//	Xe[^XWX^

	//	***** ݒe\z *****

	RegW = SHT_STATUS_HEATER_OFF										//	q[^[It
		 | SHT_STATUS_OTP_OFF											//	[h
		 | Reso;														//	蕪\@c@ZN^̏Ԃɂ

	//	***** ͂܂ *****

	DevComSendData("*** Status ");										//	󋵕\

	//	***** WX^ *****

	DevComSendData("Write");											//	󋵕\

	if (DrvShtPutSts(RegW) == 0) {										//	WX^̏ݎsH
		MngSensorNG();													//	󋵕\
		return(0);														//	ُIŒEo
	}
	MngSensorOK();														//	󋵕\

	//	***** WX^ǂݏo *****

	DevComSendData("Read");												//	󋵕\

	if (DrvShtGetSts(&Status) == 0) {									//	WX^̓ǂݏosH
		MngSensorNG();													//	󋵕\
		return(0);														//	ُIŒEo
	}
	MngSensorOK();														//	󋵕\

	//	***** f[^\ *****
/*
	0123456789012345
	XX,XX,XX  
*/
	DevComSendData("Data ");											//	󋵕\

	LibHexAscUB(vDspBuf+0, DrvShtGetLastCode());						//	MR[h
	vDspBuf[2] = ',';
	LibHexAscUB(vDspBuf+3, Status.Reg);									//	WX^l
	vDspBuf[5] = ',';
	LibHexAscUB(vDspBuf+6, Status.CRC);									//	bqb
	vDspBuf[8] = ' ';
	vDspBuf[9] = ' ';
	vDspBuf[10] = CODE_NUL;
	DevComSendData(vDspBuf);											//	ʐMf[^PUi_v

	//	***** bqbff *****

	DevComSendData("CRC");												//	󋵕\

	if (DrvShtDiagStatus(&Status) == 0) {								//	bqbُH
		MngSensorNG();													//	󋵕\
		return(0);														//	ُIŒEo
	}
	MngSensorOK();														//	󋵕\

	//	***** ݒemF *****

	DevComSendData("Compare");											//	󋵕\
	if (RegW != (Status.Reg & SHT_STATUS_MASK_PUT)) {					//	ݒ肵eقȂH
		MngSensorNG();													//	󋵕\
		return(0);														//	ُIŒEo
	}
	MngSensorOK();														//	󋵕\

	//	***** ܂ *****

	MngDspCrLf();														//	bqAke
	return(1);															//	܂łΐI
}

//============================================================================
//	ZTFx
//----------------------------------------------------------------------------
//	́F	
//	óF	ʁiOFُIAOFIj
//----------------------------------------------------------------------------
//	lF	x𑪒肵ĒʐMŌʂ\܂B
//			萳IAAs͍s܂B
//============================================================================
UB		MngSensorTmp(void)
{
	sShtM	Meas;														//	
	H		Value;														//	l

	//	***** ͂܂ *****

	DevComSendData("*** TMP ");											//	󋵕\

	//	***** Jn *****

	DevComSendData("Meas");												//	󋵕\

	if (DrvShtReqTmp() == 0) {											//	xJnsH
		MngSensorNG();													//	󋵕\
		return(0);														//	ُIŒEo
	}
	MngSensorOK();														//	󋵕\

	//	***** 芮ҋ@ *****

	DevComSendData("Wait");												//	󋵕\

	while (1) {															//	I܂ŏ
		if (DrvShtIsReady() != 0) {										//	IH
			break;														//	Eo
		}
	}
	MngSensorOK();														//	󋵕\

	//	***** f[^擾 ******

	DevComSendData("Read");												//	󋵕\

	DrvShtGetMeas(&Meas);												//	茋ʎ擾
	MngSensorOK();														//	󋵕\

	//	***** f[^\ *****
/*
	0123456789012345
	XX,XX,XX,XX
*/
	DevComSendData("Data ");											//	󋵕\

	LibHexAscUB(vDspBuf+0, DrvShtGetLastCode());						//	MR[h
	vDspBuf[2] = ',';
	LibHexAscUB(vDspBuf+3, (UB)((UH)Meas.Data >> 8));					//	茋ʂ̏ʃoCg
	vDspBuf[5] = ',';
	LibHexAscUB(vDspBuf+6, (UB)((UH)Meas.Data & 0xff));					//	茋ʂ̉ʃoCg
	vDspBuf[8] = ',';
	LibHexAscUB(vDspBuf+9, Meas.CRC);									//	bqb
	vDspBuf[11] = ' ';
	vDspBuf[12] = ' ';
	vDspBuf[13] = CODE_NUL;
	DevComSendData(vDspBuf);											//	ʐMf[^PUi_v

	//	***** bqbff *****

	DevComSendData("CRC");												//	󋵕\

	if (DrvShtDiagMeas(&Meas) == 0) {									//	bqbُH
		MngSensorNG();													//	󋵕\
		return(0);														//	ُIŒEo
	}
	MngSensorOK();														//	󋵕\

	//	***** 茋ʕ\ *****
/*
	0123456789012345
	+XXX.Yc  
*/

	DevComSendData("Result ");											//	󋵕\

DevSigPR_T1_H();
	Value = DrvShtCnvTmp(&Meas);										//	茋ʂ𕨗ʂɕϊ
DevSigPR_T1_L();

	if (Value < 0) {													//	}CiXH
		Value = ~Value + 1;												//	ΒlZo
		vDspBuf[0] = '-';												//	LZbg
	}
	else {																//	}CiX
		vDspBuf[0] = '+';												//	LZbg
	}

	LibItoA4(vDspBuf+1, (UH)Value);										//	SPOiɕϊ	XXXY
	vDspBuf[5] = vDspBuf[4];											//	_ȉPʂړ
	vDspBuf[4] = '.';													//	_Zbg

	vDspBuf[6] = 'c';
	vDspBuf[7] = ' ';
	vDspBuf[8] = ' ';
	vDspBuf[9] = CODE_NUL;
	DevComSendData(vDspBuf);											//	肳ꂽxPOiŕ\

	//	***** ܂ *****

	MngDspCrLf();														//	bqAke
	return(1);															//	܂łΐI
}

//============================================================================
//	ZTFx
//----------------------------------------------------------------------------
//	́F	
//	óF	ʁiOFُIAOFIj
//----------------------------------------------------------------------------
//	lF	x𑪒肵ĒʐMŌʂ\܂B
//			萳IAAs͍s܂B
//============================================================================
UB		MngSensorHum(void)
{
	sShtM	Meas;														//	
	UH		Value;														//	l

	//	***** ͂܂ *****

	DevComSendData("*** HUM ");											//	󋵕\

	//	***** Jn *****

	DevComSendData("Meas");												//	󋵕\

	if (DrvShtReqHum() == 0) {											//	xJnsH
		MngSensorNG();													//	󋵕\
		return(0);														//	ُIŒEo
	}
	MngSensorOK();														//	󋵕\

	//	***** 芮ҋ@ *****

	DevComSendData("Wait");												//	󋵕\

	while (1) {															//	I܂ŏ
		if (DrvShtIsReady() != 0) {										//	IH
			break;														//	Eo
		}
	}
	MngSensorOK();														//	󋵕\

	//	***** f[^擾 ******

	DevComSendData("Read");												//	󋵕\

	DrvShtGetMeas(&Meas);												//	茋ʎ擾
	MngSensorOK();														//	󋵕\

	//	***** f[^\ *****
/*
	0123456789012345
	XX,XX,XX,XX
*/
	DevComSendData("Data ");											//	󋵕\

	LibHexAscUB(vDspBuf+0, DrvShtGetLastCode());						//	MR[h
	vDspBuf[2] = ',';
	LibHexAscUB(vDspBuf+3, (UB)((UH)Meas.Data >> 8));					//	茋ʂ̏ʃoCg
	vDspBuf[5] = ',';
	LibHexAscUB(vDspBuf+6, (UB)((UH)Meas.Data & 0xff));					//	茋ʂ̉ʃoCg
	vDspBuf[8] = ',';
	LibHexAscUB(vDspBuf+9, Meas.CRC);									//	bqb
	vDspBuf[11] = ' ';
	vDspBuf[12] = ' ';
	vDspBuf[13] = CODE_NUL;
	DevComSendData(vDspBuf);											//	ʐMf[^PUi_v

	//	***** bqbff *****

	DevComSendData("CRC");												//	󋵕\

	if (DrvShtDiagMeas(&Meas) == 0) {									//	bqbُH
		MngSensorNG();													//	󋵕\
		return(0);														//	ُIŒEo
	}
	MngSensorOK();														//	󋵕\

	//	***** 茋ʕ\ *****
/*
	0123456789012345
	XXX.Y%  
*/

	DevComSendData("Result ");											//	󋵕\

DevSigPR_H1_H();
	Value = DrvShtCnvHum(&Meas);										//	茋ʂ𕨗ʂɕϊ
DevSigPR_H1_L();

	LibItoA4(vDspBuf, (UH)Value);										//	SPOiɕϊ	XXXY
	vDspBuf[4] = vDspBuf[3];											//	_ȉPʂړ
	vDspBuf[3] = '.';													//	_Zbg

	vDspBuf[5] = '%';
	vDspBuf[6] = ' ';
	vDspBuf[7] = ' ';
	vDspBuf[8] = CODE_NUL;
	DevComSendData(vDspBuf);											//	肳ꂽxPOiŕ\

	//	***** ܂ *****

	MngDspCrLf();														//	bqAke
	return(1);															//	܂łΐI
}

//============================================================================
//	mf\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ʐMłmfʒm܂B
//============================================================================
void	MngSensorNG(void)
{
	DevComSendData(":NG");												//	󋵕\
	MngDspCrLf();														//	bqAke
}

//============================================================================
//	nj\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ʐMłnjʒm܂B
//============================================================================
void	MngSensorOK(void)
{
	DevComSendData(":OK, ");											//	󋵕\
}

//	
//	
//
// 		\
//
//	
//	
void	MngDsp______(void) {}											//	op֐

//============================================================================
//	uN\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	uNƂ𒲕VAʐMŒʒm܂B
//============================================================================
void	MngDspHello(void)
{
	//	***** o *****

	MngDspCrLf();														//	bqAke
	MngDspCrLf();														//	bqAke

	//	***** ^Cg *****

	DevComSendData(tSystemName);										//	VXe

	DevComSendData("  Ver");											//	o
	DevComSendData(tVersion);											//	o[Wԍ
	MngDspCrLf();														//	bqAke

	DevComSendData(tCopyright);											//	쐬
	MngDspCrLf();														//	bqAke

	//	***** ܂ *****

	MngDspCrLf();														//	bqAke
}

//============================================================================
//	As̑M
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	VAʐMŕAsR[h𑗐M܂B
//============================================================================
void	MngDspCrLf(void)
{
	DevComSendData(tCrLf);												//	bqAke
}

//	
//	
//
// 		Cu
//
//	
//	
void	Lib______(void) {}												//	op֐

//============================================================================
//	PoCglPUiɕϊ
//----------------------------------------------------------------------------
//	́F	i[obt@iQ{PjAlA
//	óF	i[obt@
//----------------------------------------------------------------------------
//	lF	PoCglQ̂PUiɕϊ܂B
//============================================================================
UB*		LibHexAscUB(UB *Buffer, UB Value)
{
	Buffer[0] = tCnvHexAscL[Value >> 4];								//	ʂSrbgϊ
	Buffer[1] = tCnvHexAscL[Value & 0x0f];								//	ʂSrbgϊ
	Buffer[2] = CODE_NUL;												//	I[R[hZbg

	return(Buffer);														//	obt@AhXԂ܂
}

//============================================================================
//	QoCgQoCgQoCg
//----------------------------------------------------------------------------
//	́F	񏜐A
//	óF	
//----------------------------------------------------------------------------
//	lF	QoCg̏Zs܂B
//============================================================================
UH		LibDivUH(UH Value1, UH Value2)
{
	return(Value1 / Value2);											//	QoCgZʂԂ܂
}

//============================================================================
//	QoCg~QoCgSoCg
//----------------------------------------------------------------------------
//	́F	搔A搔
//	óF	
//----------------------------------------------------------------------------
//	lF	QoCg̏Zs܂B
//============================================================================
UW		LibMulUH(UH Value1, UH Value2)
{
	return((UW)Value1 * (UW)Value2);									//	QoCg̏ZʂԂ܂
}

//============================================================================
//	Cӌ̐lL[[h擾
//----------------------------------------------------------------------------
//	́F	li[AhXAL[[hi1000,100,10j
//	óF	lL[[hiPOij
//----------------------------------------------------------------------------
//	lF	QoCgl𕶎ɕϊ܂BL͂S܂łłB
//============================================================================
UB		LibPickDigit(UH *Value, UH KeyNum)
{
	UB		Digit;

	Digit = (UB)(*Value / KeyNum);										//	L[[hɑΉ鐔lZo
	*Value -= (UH)((UH)Digit * KeyNum);									//	񉉎ZpɌL[[hɑΉ鐔lr

	return(Digit + (UB)'0');											//	lL[[hԂ
}

//============================================================================
//	͋ẐSPOiϊ
//----------------------------------------------------------------------------
//	́F	i[AhXAl
//	óF	
//----------------------------------------------------------------------------
//	lF	QoCgl𕶎ɕϊ܂BL͂S܂łłB
//============================================================================
void	LibItoA4(UB *Buffer, UH Value)
{
	Buffer[0] = LibPickDigit(&Value, 1000);								//	POOÖʕҏW
	Buffer[1] = LibPickDigit(&Value,  100);								//	@POÖʕҏW
	Buffer[2] = LibPickDigit(&Value,   10);								//	@@PÖʕҏW

	Buffer[3] = (UB)Value + '0';										//	@@@P̈ʕҏW

	Buffer[4] = CODE_NUL;												//	I[Zbg
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

